package jp.sourceforge.pdt_tools.codeFolding;

import org.eclipse.php.internal.core.ast.nodes.ASTError;
import org.eclipse.php.internal.core.ast.nodes.ASTNode;
import org.eclipse.php.internal.core.ast.nodes.ArrayAccess;
import org.eclipse.php.internal.core.ast.nodes.ArrayCreation;
import org.eclipse.php.internal.core.ast.nodes.ArrayElement;
import org.eclipse.php.internal.core.ast.nodes.Assignment;
import org.eclipse.php.internal.core.ast.nodes.BackTickExpression;
import org.eclipse.php.internal.core.ast.nodes.Block;
import org.eclipse.php.internal.core.ast.nodes.BreakStatement;
import org.eclipse.php.internal.core.ast.nodes.CastExpression;
import org.eclipse.php.internal.core.ast.nodes.CatchClause;
import org.eclipse.php.internal.core.ast.nodes.ChainingInstanceCall;
import org.eclipse.php.internal.core.ast.nodes.ClassDeclaration;
import org.eclipse.php.internal.core.ast.nodes.ClassInstanceCreation;
import org.eclipse.php.internal.core.ast.nodes.ClassName;
import org.eclipse.php.internal.core.ast.nodes.CloneExpression;
import org.eclipse.php.internal.core.ast.nodes.Comment;
import org.eclipse.php.internal.core.ast.nodes.ConditionalExpression;
import org.eclipse.php.internal.core.ast.nodes.ConstantDeclaration;
import org.eclipse.php.internal.core.ast.nodes.ContinueStatement;
import org.eclipse.php.internal.core.ast.nodes.DeclareStatement;
import org.eclipse.php.internal.core.ast.nodes.DereferenceNode;
import org.eclipse.php.internal.core.ast.nodes.DoStatement;
import org.eclipse.php.internal.core.ast.nodes.EchoStatement;
import org.eclipse.php.internal.core.ast.nodes.EmptyStatement;
import org.eclipse.php.internal.core.ast.nodes.ExpressionStatement;
import org.eclipse.php.internal.core.ast.nodes.FieldAccess;
import org.eclipse.php.internal.core.ast.nodes.FieldsDeclaration;
import org.eclipse.php.internal.core.ast.nodes.ForEachStatement;
import org.eclipse.php.internal.core.ast.nodes.ForStatement;
import org.eclipse.php.internal.core.ast.nodes.FormalParameter;
import org.eclipse.php.internal.core.ast.nodes.FullyQualifiedTraitMethodReference;
import org.eclipse.php.internal.core.ast.nodes.FunctionDeclaration;
import org.eclipse.php.internal.core.ast.nodes.FunctionInvocation;
import org.eclipse.php.internal.core.ast.nodes.FunctionName;
import org.eclipse.php.internal.core.ast.nodes.GlobalStatement;
import org.eclipse.php.internal.core.ast.nodes.GotoLabel;
import org.eclipse.php.internal.core.ast.nodes.GotoStatement;
import org.eclipse.php.internal.core.ast.nodes.Identifier;
import org.eclipse.php.internal.core.ast.nodes.IfStatement;
import org.eclipse.php.internal.core.ast.nodes.IgnoreError;
import org.eclipse.php.internal.core.ast.nodes.InLineHtml;
import org.eclipse.php.internal.core.ast.nodes.Include;
import org.eclipse.php.internal.core.ast.nodes.InfixExpression;
import org.eclipse.php.internal.core.ast.nodes.InstanceOfExpression;
import org.eclipse.php.internal.core.ast.nodes.InterfaceDeclaration;
import org.eclipse.php.internal.core.ast.nodes.LambdaFunctionDeclaration;
import org.eclipse.php.internal.core.ast.nodes.ListVariable;
import org.eclipse.php.internal.core.ast.nodes.MethodDeclaration;
import org.eclipse.php.internal.core.ast.nodes.MethodInvocation;
import org.eclipse.php.internal.core.ast.nodes.NamespaceDeclaration;
import org.eclipse.php.internal.core.ast.nodes.NamespaceName;
import org.eclipse.php.internal.core.ast.nodes.PHPArrayDereferenceList;
import org.eclipse.php.internal.core.ast.nodes.ParenthesisExpression;
import org.eclipse.php.internal.core.ast.nodes.PostfixExpression;
import org.eclipse.php.internal.core.ast.nodes.PrefixExpression;
import org.eclipse.php.internal.core.ast.nodes.Program;
import org.eclipse.php.internal.core.ast.nodes.Quote;
import org.eclipse.php.internal.core.ast.nodes.Reference;
import org.eclipse.php.internal.core.ast.nodes.ReflectionVariable;
import org.eclipse.php.internal.core.ast.nodes.ReturnStatement;
import org.eclipse.php.internal.core.ast.nodes.Scalar;
import org.eclipse.php.internal.core.ast.nodes.SingleFieldDeclaration;
import org.eclipse.php.internal.core.ast.nodes.StaticConstantAccess;
import org.eclipse.php.internal.core.ast.nodes.StaticFieldAccess;
import org.eclipse.php.internal.core.ast.nodes.StaticMethodInvocation;
import org.eclipse.php.internal.core.ast.nodes.StaticStatement;
import org.eclipse.php.internal.core.ast.nodes.SwitchCase;
import org.eclipse.php.internal.core.ast.nodes.SwitchStatement;
import org.eclipse.php.internal.core.ast.nodes.ThrowStatement;
import org.eclipse.php.internal.core.ast.nodes.TraitAlias;
import org.eclipse.php.internal.core.ast.nodes.TraitAliasStatement;
import org.eclipse.php.internal.core.ast.nodes.TraitDeclaration;
import org.eclipse.php.internal.core.ast.nodes.TraitPrecedence;
import org.eclipse.php.internal.core.ast.nodes.TraitPrecedenceStatement;
import org.eclipse.php.internal.core.ast.nodes.TraitUseStatement;
import org.eclipse.php.internal.core.ast.nodes.TryStatement;
import org.eclipse.php.internal.core.ast.nodes.UnaryOperation;
import org.eclipse.php.internal.core.ast.nodes.UseStatement;
import org.eclipse.php.internal.core.ast.nodes.UseStatementPart;
import org.eclipse.php.internal.core.ast.nodes.Variable;
import org.eclipse.php.internal.core.ast.nodes.WhileStatement;
import org.eclipse.php.internal.core.ast.visitor.Visitor;

@SuppressWarnings("restriction")
public class EmptyVisitor implements Visitor {

	public void preVisit(ASTNode node) {
	}

	public void postVisit(ASTNode node) {
	}

	public boolean visit(ArrayAccess arrayAccess) {
		return apply(arrayAccess);
	}

	public void endVisit(ArrayAccess arrayAccess) {
	}

	public boolean visit(ArrayCreation arrayCreation) {
		return apply(arrayCreation);
	}

	public void endVisit(ArrayCreation arrayCreation) {
	}

	public boolean visit(ArrayElement arrayElement) {
		return apply(arrayElement);
	}

	public void endVisit(ArrayElement arrayElement) {
	}

	public boolean visit(Assignment assignment) {
		return apply(assignment);
	}

	public void endVisit(Assignment assignment) {
	}

	public boolean visit(ASTError astError) {
		return apply(astError);
	}

	public void endVisit(ASTError astError) {
	}

	public boolean visit(BackTickExpression backTickExpression) {
		return apply(backTickExpression);
	}

	public void endVisit(BackTickExpression backTickExpression) {
	}

	public boolean visit(Block block) {
		return apply(block);
	}

	public void endVisit(Block block) {
	}

	public boolean visit(BreakStatement breakStatement) {
		return apply(breakStatement);
	}

	public void endVisit(BreakStatement breakStatement) {
	}

	public boolean visit(CastExpression castExpression) {
		return apply(castExpression);
	}

	public void endVisit(CastExpression castExpression) {
	}

	public boolean visit(CatchClause catchClause) {
		return apply(catchClause);
	}

	public void endVisit(CatchClause catchClause) {
	}

	public boolean visit(ConstantDeclaration classConstantDeclaration) {
		return apply(classConstantDeclaration);
	}

	public void endVisit(ConstantDeclaration classConstantDeclaration) {
	}

	public boolean visit(ClassDeclaration classDeclaration) {
		return apply(classDeclaration);
	}

	public void endVisit(ClassDeclaration classDeclaration) {
	}

	public boolean visit(ClassInstanceCreation classInstanceCreation) {
		return apply(classInstanceCreation);
	}

	public void endVisit(ClassInstanceCreation classInstanceCreation) {
	}

	public boolean visit(ClassName className) {
		return apply(className);
	}

	public void endVisit(ClassName className) {
	}

	public boolean visit(CloneExpression cloneExpression) {
		return apply(cloneExpression);
	}

	public void endVisit(CloneExpression cloneExpression) {
	}

	public boolean visit(Comment comment) {
		return apply(comment);
	}

	public void endVisit(Comment comment) {
	}

	public boolean visit(ConditionalExpression conditionalExpression) {
		return apply(conditionalExpression);
	}

	public void endVisit(ConditionalExpression conditionalExpression) {
	}

	public boolean visit(ContinueStatement continueStatement) {
		return apply(continueStatement);
	}

	public void endVisit(ContinueStatement continueStatement) {
	}

	public boolean visit(DeclareStatement declareStatement) {
		return apply(declareStatement);
	}

	public void endVisit(DeclareStatement declareStatement) {
	}

	public boolean visit(DoStatement doStatement) {
		return apply(doStatement);
	}

	public void endVisit(DoStatement doStatement) {
	}

	public boolean visit(EchoStatement echoStatement) {
		return apply(echoStatement);
	}

	public void endVisit(EchoStatement echoStatement) {
	}

	public boolean visit(EmptyStatement emptyStatement) {
		return apply(emptyStatement);
	}

	public void endVisit(EmptyStatement emptyStatement) {
	}

	public boolean visit(ExpressionStatement expressionStatement) {
		return apply(expressionStatement);
	}

	public void endVisit(ExpressionStatement expressionStatement) {
	}

	public boolean visit(FieldAccess fieldAccess) {
		return apply(fieldAccess);
	}

	public void endVisit(FieldAccess fieldAccess) {
	}

	public boolean visit(FieldsDeclaration fieldsDeclaration) {
		return apply(fieldsDeclaration);
	}

	public void endVisit(FieldsDeclaration fieldsDeclaration) {
	}

	public boolean visit(ForEachStatement forEachStatement) {
		return apply(forEachStatement);
	}

	public void endVisit(ForEachStatement forEachStatement) {
	}

	public boolean visit(FormalParameter formalParameter) {
		return apply(formalParameter);
	}

	public void endVisit(FormalParameter formalParameter) {
	}

	public boolean visit(ForStatement forStatement) {
		return apply(forStatement);
	}

	public void endVisit(ForStatement forStatement) {
	}

	public boolean visit(FunctionDeclaration functionDeclaration) {
		return apply(functionDeclaration);
	}

	public void endVisit(FunctionDeclaration functionDeclaration) {
	}

	public boolean visit(FunctionInvocation functionInvocation) {
		return apply(functionInvocation);
	}

	public void endVisit(FunctionInvocation functionInvocation) {
	}

	public boolean visit(FunctionName functionName) {
		return apply(functionName);
	}

	public void endVisit(FunctionName functionName) {
	}

	public boolean visit(GlobalStatement globalStatement) {
		return apply(globalStatement);
	}

	public void endVisit(GlobalStatement globalStatement) {
	}

	public boolean visit(GotoLabel gotoLabel) {
		return apply(gotoLabel);
	}

	public void endVisit(GotoLabel gotoLabel) {
	}

	public boolean visit(GotoStatement gotoStatement) {
		return apply(gotoStatement);
	}

	public void endVisit(GotoStatement gotoStatement) {
	}

	public boolean visit(Identifier identifier) {
		return apply(identifier);
	}

	public void endVisit(Identifier identifier) {
	}

	public boolean visit(IfStatement ifStatement) {
		return apply(ifStatement);
	}

	public void endVisit(IfStatement ifStatement) {
	}

	public boolean visit(IgnoreError ignoreError) {
		return apply(ignoreError);
	}

	public void endVisit(IgnoreError ignoreError) {
	}

	public boolean visit(Include include) {
		return apply(include);
	}

	public void endVisit(Include include) {
	}

	public boolean visit(InfixExpression infixExpression) {
		return apply(infixExpression);
	}

	public void endVisit(InfixExpression infixExpression) {
	}

	public boolean visit(InLineHtml inLineHtml) {
		return apply(inLineHtml);
	}

	public void endVisit(InLineHtml inLineHtml) {
	}

	public boolean visit(InstanceOfExpression instanceOfExpression) {
		return apply(instanceOfExpression);
	}

	public void endVisit(InstanceOfExpression instanceOfExpression) {
	}

	public boolean visit(InterfaceDeclaration interfaceDeclaration) {
		return apply(interfaceDeclaration);
	}

	public void endVisit(InterfaceDeclaration interfaceDeclaration) {
	}

	public boolean visit(LambdaFunctionDeclaration lambdaFunctionDeclaration) {
		return apply(lambdaFunctionDeclaration);
	}

	public void endVisit(LambdaFunctionDeclaration lambdaFunctionDeclaration) {
	}

	public boolean visit(ListVariable listVariable) {
		return apply(listVariable);
	}

	public void endVisit(ListVariable listVariable) {
	}

	public boolean visit(MethodDeclaration methodDeclaration) {
		return apply(methodDeclaration);
	}

	public void endVisit(MethodDeclaration methodDeclaration) {
	}

	public boolean visit(MethodInvocation methodInvocation) {
		return apply(methodInvocation);
	}

	public void endVisit(MethodInvocation methodInvocation) {
	}

	public boolean visit(NamespaceName namespaceName) {
		return apply(namespaceName);
	}

	public void endVisit(NamespaceName namespaceName) {
	}

	public boolean visit(NamespaceDeclaration namespaceDeclaration) {
		return apply(namespaceDeclaration);
	}

	public void endVisit(NamespaceDeclaration namespaceDeclaration) {
	}

	public boolean visit(ParenthesisExpression parenthesisExpression) {
		return apply(parenthesisExpression);
	}

	public void endVisit(ParenthesisExpression parenthesisExpression) {
	}

	public boolean visit(PostfixExpression postfixExpression) {
		return apply(postfixExpression);
	}

	public void endVisit(PostfixExpression postfixExpression) {
	}

	public boolean visit(PrefixExpression prefixExpression) {
		return apply(prefixExpression);
	}

	public void endVisit(PrefixExpression prefixExpression) {
	}

	public boolean visit(Program program) {
		return apply(program);
	}

	public void endVisit(Program program) {
	}

	public boolean visit(Quote quote) {
		return apply(quote);
	}

	public void endVisit(Quote quote) {
	}

	public boolean visit(Reference reference) {
		return apply(reference);
	}

	public void endVisit(Reference reference) {
	}

	public boolean visit(ReflectionVariable reflectionVariable) {
		return apply(reflectionVariable);
	}

	public void endVisit(ReflectionVariable reflectionVariable) {
	}

	public boolean visit(ReturnStatement returnStatement) {
		return apply(returnStatement);
	}

	public void endVisit(ReturnStatement returnStatement) {
	}

	public boolean visit(Scalar scalar) {
		return apply(scalar);
	}

	public void endVisit(Scalar scalar) {
	}

	public boolean visit(SingleFieldDeclaration singleFieldDeclaration) {
		return apply(singleFieldDeclaration);
	}

	public void endVisit(SingleFieldDeclaration singleFieldDeclaration) {
	}

	public boolean visit(StaticConstantAccess classConstantAccess) {
		return apply(classConstantAccess);
	}

	public void endVisit(StaticConstantAccess staticConstantAccess) {
	}

	public boolean visit(StaticFieldAccess staticFieldAccess) {
		return apply(staticFieldAccess);
	}

	public void endVisit(StaticFieldAccess staticFieldAccess) {
	}

	public boolean visit(StaticMethodInvocation staticMethodInvocation) {
		return apply(staticMethodInvocation);
	}

	public void endVisit(StaticMethodInvocation staticMethodInvocation) {
	}

	public boolean visit(StaticStatement staticStatement) {
		return apply(staticStatement);
	}

	public void endVisit(StaticStatement staticStatement) {
	}

	public boolean visit(SwitchCase switchCase) {
		return apply(switchCase);
	}

	public void endVisit(SwitchCase switchCase) {
	}

	public boolean visit(SwitchStatement switchStatement) {
		return apply(switchStatement);
	}

	public void endVisit(SwitchStatement switchStatement) {
	}

	public boolean visit(ThrowStatement throwStatement) {
		return apply(throwStatement);
	}

	public void endVisit(ThrowStatement throwStatement) {
	}

	public boolean visit(TryStatement tryStatement) {
		return apply(tryStatement);
	}

	public void endVisit(TryStatement tryStatement) {
	}

	public boolean visit(UnaryOperation unaryOperation) {
		return apply(unaryOperation);
	}

	public void endVisit(UnaryOperation unaryOperation) {
	}

	public boolean visit(Variable variable) {
		return apply(variable);
	}

	public void endVisit(Variable variable) {
	}

	public boolean visit(UseStatement useStatement) {
		return apply(useStatement);
	}

	public void endVisit(UseStatement useStatement) {
	}

	public boolean visit(UseStatementPart useStatementPart) {
		return apply(useStatementPart);
	}

	public void endVisit(UseStatementPart useStatementPart) {
	}

	public boolean visit(WhileStatement whileStatement) {
		return apply(whileStatement);
	}

	public void endVisit(WhileStatement whileStatement) {
	}

	public boolean visit(ASTNode node) {
		return apply(node);
	}

	public void endVisit(ASTNode node) {
	}

	private boolean apply(ASTNode node) {
		node.childrenAccept(this);
		return false;
	}

	public boolean visit(ChainingInstanceCall node) {
		return apply(node);
	}

	public void endVisit(ChainingInstanceCall node) {
	}

	public boolean visit(DereferenceNode node) {
		return apply(node);
	}

	public void endVisit(DereferenceNode node) {
	}

	public boolean visit(FullyQualifiedTraitMethodReference node) {
		return apply(node);
	}

	public void endVisit(FullyQualifiedTraitMethodReference node) {
	}

	public boolean visit(PHPArrayDereferenceList node) {
		return apply(node);
	}

	public void endVisit(PHPArrayDereferenceList node) {
	}

	public boolean visit(TraitAlias node) {
		return apply(node);
	}

	public void endVisit(TraitAlias node) {
	}

	public boolean visit(TraitAliasStatement node) {
		return apply(node);
	}

	public void endVisit(TraitAliasStatement node) {
	}

	public boolean visit(TraitDeclaration node) {
		return apply(node);
	}

	public void endVisit(TraitDeclaration node) {
	}

	public boolean visit(TraitPrecedence node) {
		return apply(node);
	}

	public void endVisit(TraitPrecedence node) {
	}

	public boolean visit(TraitPrecedenceStatement node) {
		return apply(node);
	}

	public void endVisit(TraitPrecedenceStatement node) {
	}

	public boolean visit(TraitUseStatement node) {
		return apply(node);
	}

	public void endVisit(TraitUseStatement node) {
	}

}
